<?php

function load_config($filename, $optional=false) {
    if (!file_exists(__DIR__ . '/' . $filename)) {
        if ($optional)
            return null;
        else
            throw new RuntimeException("missing file $filename");
    }

    $config = json_decode(file_get_contents(__DIR__ . '/' . $filename), true);

    if ($config === null)
        throw new RuntimeException("file $filename is not valid JSON");

    return $config;
}

function set_accept_locale($supported_languages=null) {
    if (!isset($_SERVER['HTTP_ACCEPT_LANGUAGE']))
        return null;

    foreach (explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']) as $locale) {
        if (!preg_match('/^(\w\w)(?:[-_](\w\w))?(\.\w+)?$/', $locale, $m))
            continue;

        $lang = $m[1];
        $region = isset($m[2]) ? '_'.$m[2] : '';
        $ext = isset($m[3]) ? $m[3] : '';

        if ($supported_languages === null || in_array($lang, $supported_languages)) {
            $locale = setlocale(LC_ALL,
                $lang.$region.$ext,
                $lang.$region.'.utf8',
                $lang.$region,
                $lang.$ext,
                $lang.'.utf8',
                $lang);
            return $locale;
        }
    }

    return null;
}
